给你一个整数数组 nums 和一个正整数 threshold ,你需要选择一个正整数作为除数,然后将数组里每个数都除以它,并对除法结果求和。
请你找出能够使上述结果小于等于阈值 threshold 的除数中 最小 的那个。
每个数除以除数后都向上取整,比方说 7/3 = 3 , 10/2 = 5 。
题目保证一定有解。
示例 1:
输入:nums = [1,2,5,9], threshold = 6
输出:5
解释:如果除数为 1 ,我们可以得到和为 17 (1+2+5+9)。
如果除数为 4 ,我们可以得到和为 7 (1+1+2+3) 。如果除数为 5 ,和为 5 (1+1+1+2)。
示例 2:
输入:nums = [2,3,5,7,11], threshold = 11
输出:3
示例 3:
输入:nums = [19], threshold = 5
输出:4
提示:
1 <= nums.length <= 5 * 10^4
1 <= nums[i] <= 10^6
nums.length <= threshold <= 10^6
链接:https://leetcode-cn.com/problems/find-the-smallest-divisor-given-a-threshold
思路分析:
题意就是找最小的除数x,使得∑(nums[i]/x) (向上取整) <= threshold.
为什么会想到二分枚举呢?
首先,我会考虑暴力做法,但这种数据范围暴力肯定TLE. 然后,我们观察一下每个除数经过运算后的结果(假设除数为x, cal(x)为运算结果).
我们可以发现,x = 1时,cal(x)是最大的,越往后,cal(x)越小,直到x >= 数组中的最大值时,cal(x)就是1+1+1…
因此,y = cal(x) 是一个有序序列,可以想到二分枚举。并且我们要求最小除数,也就是转化为求二分区间的左边界。
对于二分枚举,我们需要一个条件来缩短区间。这个条件就是cal(x)和threshold的关系。
- cal(mid) > threshold 表明mid取小了,令 l = mid+1 区间向右压缩。
- cal(mid) <= threshold 表明mid取大了,令 r = mid 区间向左压缩直至左边界。
class Solution {
public:
int cal(vector<int> nums, int x)
{
int res = 0;
for(int i = 0;i < nums.size();i++)
{
int t = nums[i]/x;
if(nums[i]%x != 0) t++; //无法整除,向上取整
res += t;
}
return res;
}
int smallestDivisor(vector<int>& nums, int threshold) {
int l = 1, r = 1000000;
while(l < r)
{
int mid = l+r>>1;
if(cal(nums,mid) > threshold)
{
l = mid+1;
}
else r = mid;
}
return l;
}
};